"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createContainer = exports.createStandard = exports.create = exports.errors = void 0;
const errors = require("./errors");
exports.errors = errors;
const Container_1 = require("./Container");
const activation_1 = require("./middlewares/activation");
const config_1 = require("./middlewares/config");
const ConfigProvider_1 = require("./ConfigProvider");
const Service_1 = require("./decorators/Service");
const deprecated_1 = require("./middlewares/deprecated");
__exportStar(require("./Definition"), exports);
__exportStar(require("./Container"), exports);
__exportStar(require("./Reference"), exports);
__exportStar(require("./types"), exports);
__exportStar(require("./ContainerArg"), exports);
__exportStar(require("./referenceFunc"), exports);
__exportStar(require("./configFunc"), exports);
__exportStar(require("./Lookup"), exports);
__exportStar(require("./middlewares/activation"), exports);
__exportStar(require("./middlewares/config"), exports);
__exportStar(require("./createAnnotationFactory"), exports);
__exportStar(require("./middlewares/deprecated"), exports);
var Service_2 = require("./decorators/Service");
Object.defineProperty(exports, "Service", { enumerable: true, get: function () { return Service_2.Service; } });
Object.defineProperty(exports, "getDefinitionForClass", { enumerable: true, get: function () { return Service_2.getDefinitionForClass; } });
var Annotation_1 = require("./decorators/Annotation");
Object.defineProperty(exports, "Annotation", { enumerable: true, get: function () { return Annotation_1.Annotation; } });
var Inject_1 = require("./decorators/Inject");
Object.defineProperty(exports, "Inject", { enumerable: true, get: function () { return Inject_1.Inject; } });
var Config_1 = require("./decorators/Config");
Object.defineProperty(exports, "Config", { enumerable: true, get: function () { return Config_1.Config; } });
var Deprecated_1 = require("./decorators/Deprecated");
Object.defineProperty(exports, "Deprecated", { enumerable: true, get: function () { return Deprecated_1.Deprecated; } });
var OnActivation_1 = require("./decorators/OnActivation");
Object.defineProperty(exports, "OnActivation", { enumerable: true, get: function () { return OnActivation_1.OnActivation; } });
var AutowiredService_1 = require("./decorators/AutowiredService");
Object.defineProperty(exports, "AutowiredService", { enumerable: true, get: function () { return AutowiredService_1.AutowiredService; } });
var preloadServiceModules_1 = require("./preloadServiceModules");
Object.defineProperty(exports, "preloadServiceModules", { enumerable: true, get: function () { return preloadServiceModules_1.preloadServiceModules; } });
var createNamespace_1 = require("./createNamespace");
Object.defineProperty(exports, "createNamespace", { enumerable: true, get: function () { return createNamespace_1.createNamespace; } });
Object.defineProperty(exports, "namespaceEntry", { enumerable: true, get: function () { return createNamespace_1.namespaceEntry; } });
function create(parent) {
    return new Container_1.Container(parent);
}
exports.create = create;
/**
 * Creates preconfigured container:
 * * has all middlewares registered
 * * @Service decorator uses new container
 * * configMiddleware that uses given config object
 */
function createStandard(options = {}) {
    const container = new Container_1.Container(options.parent);
    const opts = options || {};
    const configureServiceDecorator = options.configureServiceDecorator === undefined ? true : options.configureServiceDecorator;
    if (configureServiceDecorator) {
        Service_1.Service.useContainer(container);
    }
    container
        .addMiddleware(activation_1.activationMiddleware)
        .addMiddleware(config_1.configMiddleware(ConfigProvider_1.configProviderForObject(opts.config || {})))
        .addMiddleware(deprecated_1.deprecatedMiddleware(opts.deprecationMessageFunc));
    return container;
}
exports.createStandard = createStandard;
exports.createContainer = create;
